import { integer, LeitnerBox, LeitnerBoxConfig, CardIdentity, Card, CardInfo } from './types';
export declare const createLeitnerBox: ({ repetitions, currentLesson, initialDecks }?: LeitnerBoxConfig) => LeitnerBox;
export declare const getCurrentLesson: (box: LeitnerBox) => integer;
export declare const setCurrentLesson: (box: LeitnerBox, currentLesson: integer) => LeitnerBox;
export declare const isLastLessonForCard: (box: LeitnerBox, identity: CardIdentity) => boolean;
export declare const getCardsForLesson: (box: LeitnerBox, lesson: integer) => Card[];
export declare const getCardInfo: (box: LeitnerBox, identity: CardIdentity) => CardInfo;
export declare const getCardsForCurrentLesson: (box: LeitnerBox) => Card[];
export declare const addToUnknown: (x1: LeitnerBox, x2: unknown) => LeitnerBox;
export declare const addToLearned: (x1: LeitnerBox, x2: unknown) => LeitnerBox;
export declare const addToLessons: (box: LeitnerBox, card: Card) => LeitnerBox;
export declare const moveToUnknown: (box: LeitnerBox, identity: CardIdentity) => LeitnerBox;
export declare const moveToLearned: (box: LeitnerBox, identity: CardIdentity) => LeitnerBox;
export declare const moveToLessons: (box: LeitnerBox, identity: CardIdentity) => LeitnerBox;
