"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.assert = exports.lensMatchIdentity = exports.buildEmptyDecks = exports.buildRepeatLessons = exports.fib = void 0;
const R = __importStar(require("ramda"));
const fib = (n) => (n === 0 ? 0 : (0, exports.fib)(n - 1) + n + 1);
exports.fib = fib;
const range = (count) => {
    return [...Array(count).keys()];
};
const buildRepeatLessons = (count, repetitions) => {
    const lessons = [];
    for (let i = 0; i < count; i++) {
        const a = [];
        for (let j = 1; j <= repetitions; j++) {
            a.push((i + (0, exports.fib)(j)) % count);
        }
        lessons.push(a);
    }
    return lessons;
};
exports.buildRepeatLessons = buildRepeatLessons;
const buildEmptyDecks = (count) => {
    return range(count + 2).map((_) => []);
};
exports.buildEmptyDecks = buildEmptyDecks;
const lensMatchIdentity = (identity) => R.lens(R.find(identity), (val, arr, idx = R.findIndex(identity, arr)) => R.update(idx > -1 ? idx : R.length(arr), val, arr));
exports.lensMatchIdentity = lensMatchIdentity;
const assert = (condition, message) => {
    if (!condition) {
        throw new Error(message);
    }
};
exports.assert = assert;
